/**
 * auth
 * Authentication Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The TenantUser model module.
 * @module model/TenantUser
 * @version 0.0.2
 */
class TenantUser {
    /**
     * Constructs a new <code>TenantUser</code>.
     * Relationship object that connects users to a tenant
     * @alias module:model/TenantUser
     */
    constructor() { 
        
        TenantUser.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>TenantUser</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TenantUser} obj Optional instance to populate.
     * @return {module:model/TenantUser} The populated <code>TenantUser</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new TenantUser();

            if (data.hasOwnProperty('AccessLevel')) {
                obj['AccessLevel'] = ApiClient.convertToType(data['AccessLevel'], 'String');
            }
            if (data.hasOwnProperty('Auth0UserID')) {
                obj['Auth0UserID'] = ApiClient.convertToType(data['Auth0UserID'], 'String');
            }
            if (data.hasOwnProperty('AccountID')) {
                obj['AccountID'] = ApiClient.convertToType(data['AccountID'], 'String');
            }
            if (data.hasOwnProperty('ContactID')) {
                obj['ContactID'] = ApiClient.convertToType(data['ContactID'], 'String');
            }
            if (data.hasOwnProperty('CompanyName')) {
                obj['CompanyName'] = ApiClient.convertToType(data['CompanyName'], 'String');
            }
            if (data.hasOwnProperty('TaxnexusAccount')) {
                obj['TaxnexusAccount'] = ApiClient.convertToType(data['TaxnexusAccount'], 'String');
            }
            if (data.hasOwnProperty('TenantActive')) {
                obj['TenantActive'] = ApiClient.convertToType(data['TenantActive'], 'Boolean');
            }
            if (data.hasOwnProperty('TenantID')) {
                obj['TenantID'] = ApiClient.convertToType(data['TenantID'], 'String');
            }
            if (data.hasOwnProperty('TenantName')) {
                obj['TenantName'] = ApiClient.convertToType(data['TenantName'], 'String');
            }
            if (data.hasOwnProperty('TenantStatus')) {
                obj['TenantStatus'] = ApiClient.convertToType(data['TenantStatus'], 'String');
            }
            if (data.hasOwnProperty('TenantType')) {
                obj['TenantType'] = ApiClient.convertToType(data['TenantType'], 'String');
            }
            if (data.hasOwnProperty('TenantVersion')) {
                obj['TenantVersion'] = ApiClient.convertToType(data['TenantVersion'], 'String');
            }
            if (data.hasOwnProperty('Username')) {
                obj['Username'] = ApiClient.convertToType(data['Username'], 'String');
            }
            if (data.hasOwnProperty('UserEmail')) {
                obj['UserEmail'] = ApiClient.convertToType(data['UserEmail'], 'String');
            }
            if (data.hasOwnProperty('UserFullName')) {
                obj['UserFullName'] = ApiClient.convertToType(data['UserFullName'], 'String');
            }
            if (data.hasOwnProperty('UserID')) {
                obj['UserID'] = ApiClient.convertToType(data['UserID'], 'String');
            }
        }
        return obj;
    }


}

/**
 * The makeTenantUser access level for this User
 * @member {String} AccessLevel
 */
TenantUser.prototype['AccessLevel'] = undefined;

/**
 * Auth0 User ID
 * @member {String} Auth0UserID
 */
TenantUser.prototype['Auth0UserID'] = undefined;

/**
 * Account ID
 * @member {String} AccountID
 */
TenantUser.prototype['AccountID'] = undefined;

/**
 * Contact ID
 * @member {String} ContactID
 */
TenantUser.prototype['ContactID'] = undefined;

/**
 * Account Name
 * @member {String} CompanyName
 */
TenantUser.prototype['CompanyName'] = undefined;

/**
 * Taxnexus Account
 * @member {String} TaxnexusAccount
 */
TenantUser.prototype['TaxnexusAccount'] = undefined;

/**
 * Tenant active?
 * @member {Boolean} TenantActive
 */
TenantUser.prototype['TenantActive'] = undefined;

/**
 * The Tenant ID
 * @member {String} TenantID
 */
TenantUser.prototype['TenantID'] = undefined;

/**
 * Tenant Name
 * @member {String} TenantName
 */
TenantUser.prototype['TenantName'] = undefined;

/**
 * Tenant Status
 * @member {String} TenantStatus
 */
TenantUser.prototype['TenantStatus'] = undefined;

/**
 * Tenant type
 * @member {String} TenantType
 */
TenantUser.prototype['TenantType'] = undefined;

/**
 * Tenant Version
 * @member {String} TenantVersion
 */
TenantUser.prototype['TenantVersion'] = undefined;

/**
 * Username
 * @member {String} Username
 */
TenantUser.prototype['Username'] = undefined;

/**
 * User Email Address
 * @member {String} UserEmail
 */
TenantUser.prototype['UserEmail'] = undefined;

/**
 * User Full Name
 * @member {String} UserFullName
 */
TenantUser.prototype['UserFullName'] = undefined;

/**
 * The User ID
 * @member {String} UserID
 */
TenantUser.prototype['UserID'] = undefined;






export default TenantUser;

