# Board.DevelopersApi

All URIs are relative to *http://board.vernonkeenan.com:8080/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**postDevelopers**](DevelopersApi.md#postDevelopers) | **POST** /developers | Onboard new developer



## postDevelopers

> RuleExecution postDevelopers(developerRequest)

Onboard new developer

Register new developers with POST

### Example

```javascript
import Board from 'board';
let defaultClient = Board.ApiClient.instance;
// Configure API key authorization: ApiKeyAuth
let ApiKeyAuth = defaultClient.authentications['ApiKeyAuth'];
ApiKeyAuth.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiKeyAuth.apiKeyPrefix = 'Token';

let apiInstance = new Board.DevelopersApi();
let developerRequest = new Board.Developer(); // Developer | A single Developer struct for onboarding
apiInstance.postDevelopers(developerRequest, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **developerRequest** | [**Developer**](Developer.md)| A single Developer struct for onboarding | 

### Return type

[**RuleExecution**](RuleExecution.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

