/**
 * board
 * Taxnexus Onboarding Service
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import IQ from '../model/IQ';
import RuleExecution from '../model/RuleExecution';

/**
* Iq service.
* @module api/IqApi
* @version 0.0.2
*/
export default class IqApi {

    /**
    * Constructs a new IqApi. 
    * @alias module:api/IqApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the postIQ operation.
     * @callback module:api/IqApi~postIQCallback
     * @param {String} error Error message, if any.
     * @param {module:model/RuleExecution} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Onboard new new Taxnexus IQ Customer
     * Register new Taxnexus IQ Customer with POST
     * @param {module:model/IQ} iqRequest A single Taxnexus IQ Customer struct for onboarding
     * @param {module:api/IqApi~postIQCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/RuleExecution}
     */
    postIQ(iqRequest, callback) {
      let postBody = iqRequest;
      // verify the required parameter 'iqRequest' is set
      if (iqRequest === undefined || iqRequest === null) {
        throw new Error("Missing the required parameter 'iqRequest' when calling postIQ");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = RuleExecution;
      return this.apiClient.callApi(
        '/iqs', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
