/**
 * board
 * Taxnexus Onboarding Service
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import UserAuth from '../model/UserAuth';

/**
* UserAuth service.
* @module api/UserAuthApi
* @version 0.0.2
*/
export default class UserAuthApi {

    /**
    * Constructs a new UserAuthApi. 
    * @alias module:api/UserAuthApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getUserAuth operation.
     * @callback module:api/UserAuthApi~getUserAuthCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UserAuth} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a single UserAuth object
     * Return a single UserAuth object from datastore as a Singleton
     * @param {String} usernamePath Username in the query path
     * @param {module:api/UserAuthApi~getUserAuthCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UserAuth}
     */
    getUserAuth(usernamePath, callback) {
      let postBody = null;
      // verify the required parameter 'usernamePath' is set
      if (usernamePath === undefined || usernamePath === null) {
        throw new Error("Missing the required parameter 'usernamePath' when calling getUserAuth");
      }

      let pathParams = {
        'usernamePath': usernamePath
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = UserAuth;
      return this.apiClient.callApi(
        '/userauths/{usernamePath}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
