/**
 * board
 * Taxnexus Onboarding Service
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Database model module.
 * @module model/Database
 * @version 0.0.2
 */
class Database {
    /**
     * Constructs a new <code>Database</code>.
     * A Database provisioned and owned by a Tenant
     * @alias module:model/Database
     */
    constructor() { 
        
        Database.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Database</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Database} obj Optional instance to populate.
     * @return {module:model/Database} The populated <code>Database</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Database();

            if (data.hasOwnProperty('Active')) {
                obj['Active'] = ApiClient.convertToType(data['Active'], 'Boolean');
            }
            if (data.hasOwnProperty('ClusterID')) {
                obj['ClusterID'] = ApiClient.convertToType(data['ClusterID'], 'String');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('DSN')) {
                obj['DSN'] = ApiClient.convertToType(data['DSN'], 'String');
            }
            if (data.hasOwnProperty('DatabaseName')) {
                obj['DatabaseName'] = ApiClient.convertToType(data['DatabaseName'], 'String');
            }
            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('Microservices')) {
                obj['Microservices'] = ApiClient.convertToType(data['Microservices'], 'String');
            }
            if (data.hasOwnProperty('Status')) {
                obj['Status'] = ApiClient.convertToType(data['Status'], 'String');
            }
            if (data.hasOwnProperty('TenantID')) {
                obj['TenantID'] = ApiClient.convertToType(data['TenantID'], 'String');
            }
            if (data.hasOwnProperty('Type')) {
                obj['Type'] = ApiClient.convertToType(data['Type'], 'String');
            }
        }
        return obj;
    }


}

/**
 * Is this database active?
 * @member {Boolean} Active
 */
Database.prototype['Active'] = undefined;

/**
 * The ID of the Cluster in which this database is deployed
 * @member {String} ClusterID
 */
Database.prototype['ClusterID'] = undefined;

/**
 * Created By
 * @member {String} CreatedByID
 */
Database.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Database.prototype['CreatedDate'] = undefined;

/**
 * Database connection string
 * @member {String} DSN
 */
Database.prototype['DSN'] = undefined;

/**
 * The name of the physical database in the cluster
 * @member {String} DatabaseName
 */
Database.prototype['DatabaseName'] = undefined;

/**
 * Record Id
 * @member {String} ID
 */
Database.prototype['ID'] = undefined;

/**
 * Last Modified By
 * @member {String} LastModifiedByID
 */
Database.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modifed Date
 * @member {String} LastModifiedDate
 */
Database.prototype['LastModifiedDate'] = undefined;

/**
 * List of Taxnexus microservices implemented by this Database
 * @member {String} Microservices
 */
Database.prototype['Microservices'] = undefined;

/**
 * The current status of this Tenant
 * @member {String} Status
 */
Database.prototype['Status'] = undefined;

/**
 * The ID of the tenant who owns this Database
 * @member {String} TenantID
 */
Database.prototype['TenantID'] = undefined;

/**
 * The type of Database (mysql, etc)
 * @member {String} Type
 */
Database.prototype['Type'] = undefined;






export default Database;

