/**
 * crm
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Asset from '../model/Asset';
import AssetRequest from '../model/AssetRequest';
import AssetResponse from '../model/AssetResponse';
import DeleteResponse from '../model/DeleteResponse';
import Error from '../model/Error';

/**
* Assets service.
* @module api/AssetsApi
* @version 0.0.2
*/
export default class AssetsApi {

    /**
    * Constructs a new AssetsApi. 
    * @alias module:api/AssetsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the deleteAsset operation.
     * @callback module:api/AssetsApi~deleteAssetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DeleteResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete An Asset
     * Delete Taxnexus Asset record
     * @param {Object} opts Optional parameters
     * @param {String} opts.assetId Taxnexus Record Id of an Asset
     * @param {module:api/AssetsApi~deleteAssetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DeleteResponse}
     */
    deleteAsset(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'assetId': opts['assetId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DeleteResponse;
      return this.apiClient.callApi(
        '/assets', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getAssets operation.
     * @callback module:api/AssetsApi~getAssetsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AssetResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of assets
     * Return a list of all available Assets
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {String} opts.accountId Taxnexus Record Id of an Account
     * @param {String} opts.assetId Taxnexus Record Id of an Asset
     * @param {module:api/AssetsApi~getAssetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AssetResponse}
     */
    getAssets(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'accountId': opts['accountId'],
        'assetId': opts['assetId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = AssetResponse;
      return this.apiClient.callApi(
        '/assets', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getAssetsObservable operation.
     * @callback module:api/AssetsApi~getAssetsObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Asset>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Taxnexus Assets in an observable array
     * A list of assets in a simple JSON array
     * @param {Object} opts Optional parameters
     * @param {String} opts.accountId Taxnexus Record Id of an Account
     * @param {String} opts.assetId Taxnexus Record Id of an Asset
     * @param {module:api/AssetsApi~getAssetsObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Asset>}
     */
    getAssetsObservable(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'accountId': opts['accountId'],
        'assetId': opts['assetId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Asset];
      return this.apiClient.callApi(
        '/assets/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postAssets operation.
     * @callback module:api/AssetsApi~postAssetsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AssetResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new asset to Taxnexus
     * Asset record to be added
     * @param {module:model/AssetRequest} assetRequest An array of new Asset records
     * @param {module:api/AssetsApi~postAssetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AssetResponse}
     */
    postAssets(assetRequest, callback) {
      let postBody = assetRequest;
      // verify the required parameter 'assetRequest' is set
      if (assetRequest === undefined || assetRequest === null) {
        throw new Error("Missing the required parameter 'assetRequest' when calling postAssets");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = AssetResponse;
      return this.apiClient.callApi(
        '/assets', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putAsset operation.
     * @callback module:api/AssetsApi~putAssetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AssetResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a single asset
     * Update a single asset specified by assetId
     * @param {module:model/AssetRequest} assetRequest An array of new Asset records
     * @param {module:api/AssetsApi~putAssetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AssetResponse}
     */
    putAsset(assetRequest, callback) {
      let postBody = assetRequest;
      // verify the required parameter 'assetRequest' is set
      if (assetRequest === undefined || assetRequest === null) {
        throw new Error("Missing the required parameter 'assetRequest' when calling putAsset");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = AssetResponse;
      return this.apiClient.callApi(
        '/assets', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
