/**
 * crm
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Contact from '../model/Contact';
import ContactRequest from '../model/ContactRequest';
import ContactResponse from '../model/ContactResponse';
import DeleteResponse from '../model/DeleteResponse';
import Error from '../model/Error';

/**
* Contacts service.
* @module api/ContactsApi
* @version 0.0.2
*/
export default class ContactsApi {

    /**
    * Constructs a new ContactsApi. 
    * @alias module:api/ContactsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the deleteContact operation.
     * @callback module:api/ContactsApi~deleteContactCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DeleteResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a Contact
     * Delete Taxnexus Contact record
     * @param {Object} opts Optional parameters
     * @param {String} opts.contactId Taxnexus Contact record ID
     * @param {module:api/ContactsApi~deleteContactCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DeleteResponse}
     */
    deleteContact(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'contactId': opts['contactId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DeleteResponse;
      return this.apiClient.callApi(
        '/contacts', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getContacts operation.
     * @callback module:api/ContactsApi~getContactsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContactResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of contacts
     * Return a list of all available Contacts
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {String} opts.contactId Taxnexus Contact record ID
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.email Email address used for identity lookup
     * @param {String} opts.name The Name of this Object
     * @param {module:api/ContactsApi~getContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContactResponse}
     */
    getContacts(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'contactId': opts['contactId'],
        'active': opts['active'],
        'email': opts['email'],
        'name': opts['name']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ContactResponse;
      return this.apiClient.callApi(
        '/contacts', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getContactsObservable operation.
     * @callback module:api/ContactsApi~getContactsObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Contact>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Taxnexus Contacts in an observable array
     * A list of contacts in a simple JSON array
     * @param {Object} opts Optional parameters
     * @param {String} opts.contactId Taxnexus Contact record ID
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.email Email address used for identity lookup
     * @param {String} opts.name The Name of this Object
     * @param {module:api/ContactsApi~getContactsObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Contact>}
     */
    getContactsObservable(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'contactId': opts['contactId'],
        'active': opts['active'],
        'email': opts['email'],
        'name': opts['name']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Contact];
      return this.apiClient.callApi(
        '/contacts/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postContacts operation.
     * @callback module:api/ContactsApi~postContactsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContactResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add new contacts
     * Contact record to be added
     * @param {module:model/ContactRequest} contactsRequest An array of new Contact records
     * @param {module:api/ContactsApi~postContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContactResponse}
     */
    postContacts(contactsRequest, callback) {
      let postBody = contactsRequest;
      // verify the required parameter 'contactsRequest' is set
      if (contactsRequest === undefined || contactsRequest === null) {
        throw new Error("Missing the required parameter 'contactsRequest' when calling postContacts");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ContactResponse;
      return this.apiClient.callApi(
        '/contacts', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putContacts operation.
     * @callback module:api/ContactsApi~putContactsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContactResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Contact
     * Update Contact records
     * @param {module:model/ContactRequest} contactsRequest An array of new Contact records
     * @param {module:api/ContactsApi~putContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContactResponse}
     */
    putContacts(contactsRequest, callback) {
      let postBody = contactsRequest;
      // verify the required parameter 'contactsRequest' is set
      if (contactsRequest === undefined || contactsRequest === null) {
        throw new Error("Missing the required parameter 'contactsRequest' when calling putContacts");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ContactResponse;
      return this.apiClient.callApi(
        '/contacts', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
