/**
 * crm
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import DeleteResponse from '../model/DeleteResponse';
import Error from '../model/Error';
import Lead from '../model/Lead';
import LeadRequest from '../model/LeadRequest';
import LeadResponse from '../model/LeadResponse';

/**
* Leads service.
* @module api/LeadsApi
* @version 0.0.2
*/
export default class LeadsApi {

    /**
    * Constructs a new LeadsApi. 
    * @alias module:api/LeadsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the deleteLead operation.
     * @callback module:api/LeadsApi~deleteLeadCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DeleteResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a Contact
     * Delete Taxnexus Lead record
     * @param {Object} opts Optional parameters
     * @param {String} opts.leadId Taxnexus Lead record ID
     * @param {module:api/LeadsApi~deleteLeadCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DeleteResponse}
     */
    deleteLead(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'leadId': opts['leadId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DeleteResponse;
      return this.apiClient.callApi(
        '/leads', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getLeads operation.
     * @callback module:api/LeadsApi~getLeadsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LeadResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of contacts
     * Return a list of all available Leads
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {String} opts.leadId Taxnexus Lead record ID
     * @param {String} opts.email Email address used for identity lookup
     * @param {String} opts.name The Name of this Object
     * @param {module:api/LeadsApi~getLeadsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LeadResponse}
     */
    getLeads(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'leadId': opts['leadId'],
        'email': opts['email'],
        'name': opts['name']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = LeadResponse;
      return this.apiClient.callApi(
        '/leads', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getLeadsObservable operation.
     * @callback module:api/LeadsApi~getLeadsObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Lead>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Taxnexus Leads in an observable array
     * A list of leads in a simple JSON array
     * @param {Object} opts Optional parameters
     * @param {String} opts.leadId Taxnexus Lead record ID
     * @param {String} opts.email Email address used for identity lookup
     * @param {String} opts.name The Name of this Object
     * @param {module:api/LeadsApi~getLeadsObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Lead>}
     */
    getLeadsObservable(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'leadId': opts['leadId'],
        'email': opts['email'],
        'name': opts['name']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Lead];
      return this.apiClient.callApi(
        '/leads/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postLeads operation.
     * @callback module:api/LeadsApi~postLeadsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LeadResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add new Leads
     * Lead records to be added
     * @param {module:model/LeadRequest} leadRequest An array of new Lead records
     * @param {module:api/LeadsApi~postLeadsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LeadResponse}
     */
    postLeads(leadRequest, callback) {
      let postBody = leadRequest;
      // verify the required parameter 'leadRequest' is set
      if (leadRequest === undefined || leadRequest === null) {
        throw new Error("Missing the required parameter 'leadRequest' when calling postLeads");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = LeadResponse;
      return this.apiClient.callApi(
        '/leads', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putLeads operation.
     * @callback module:api/LeadsApi~putLeadsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LeadResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Leads
     * Update Lead records
     * @param {module:model/LeadRequest} leadRequest An array of new Lead records
     * @param {module:api/LeadsApi~putLeadsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LeadResponse}
     */
    putLeads(leadRequest, callback) {
      let postBody = leadRequest;
      // verify the required parameter 'leadRequest' is set
      if (leadRequest === undefined || leadRequest === null) {
        throw new Error("Missing the required parameter 'leadRequest' when calling putLeads");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = LeadResponse;
      return this.apiClient.callApi(
        '/leads', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
