/**
 * devops
 * System Operations Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Database from '../model/Database';
import DatabaseRequest from '../model/DatabaseRequest';
import DatabaseResponse from '../model/DatabaseResponse';
import Error from '../model/Error';

/**
* Database service.
* @module api/DatabaseApi
* @version 0.0.2
*/
export default class DatabaseApi {

    /**
    * Constructs a new DatabaseApi. 
    * @alias module:api/DatabaseApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getDatabase operation.
     * @callback module:api/DatabaseApi~getDatabaseCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Database} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a single Database object
     * Return a single Database object from datastore as a Singleton
     * @param {String} databaseIdPath Taxnexus Record Id of a Database
     * @param {module:api/DatabaseApi~getDatabaseCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Database}
     */
    getDatabase(databaseIdPath, callback) {
      let postBody = null;
      // verify the required parameter 'databaseIdPath' is set
      if (databaseIdPath === undefined || databaseIdPath === null) {
        throw new Error("Missing the required parameter 'databaseIdPath' when calling getDatabase");
      }

      let pathParams = {
        'databaseIdPath': databaseIdPath
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Database;
      return this.apiClient.callApi(
        '/databases/{databaseIdPath}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getDatabases operation.
     * @callback module:api/DatabaseApi~getDatabasesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DatabaseResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list Databases
     * Return a list of Database records from the datastore
     * @param {Object} opts Optional parameters
     * @param {String} opts.databaseId Taxnexus Record Id of a Database
     * @param {String} opts.companyId Taxnexus Record Id of a Company
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip? (default 0)
     * @param {module:api/DatabaseApi~getDatabasesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DatabaseResponse}
     */
    getDatabases(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'databaseId': opts['databaseId'],
        'companyId': opts['companyId'],
        'limit': opts['limit'],
        'offset': opts['offset']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DatabaseResponse;
      return this.apiClient.callApi(
        '/databases', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getDatabasesObservable operation.
     * @callback module:api/DatabaseApi~getDatabasesObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Database>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Databases in an observable array
     * Returns a Database retrieval in a observable array
     * @param {module:api/DatabaseApi~getDatabasesObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Database>}
     */
    getDatabasesObservable(callback) {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Database];
      return this.apiClient.callApi(
        '/databases/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postDatabases operation.
     * @callback module:api/DatabaseApi~postDatabasesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DatabaseResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Databases
     * Create Databases in Taxnexus
     * @param {module:model/DatabaseRequest} databaseRequest An array of Database records
     * @param {module:api/DatabaseApi~postDatabasesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DatabaseResponse}
     */
    postDatabases(databaseRequest, callback) {
      let postBody = databaseRequest;
      // verify the required parameter 'databaseRequest' is set
      if (databaseRequest === undefined || databaseRequest === null) {
        throw new Error("Missing the required parameter 'databaseRequest' when calling postDatabases");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = DatabaseResponse;
      return this.apiClient.callApi(
        '/databases', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putDatabases operation.
     * @callback module:api/DatabaseApi~putDatabasesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DatabaseResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Databases
     * Update Database in Taxnexus
     * @param {module:model/DatabaseRequest} databaseRequest An array of Database records
     * @param {module:api/DatabaseApi~putDatabasesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DatabaseResponse}
     */
    putDatabases(databaseRequest, callback) {
      let postBody = databaseRequest;
      // verify the required parameter 'databaseRequest' is set
      if (databaseRequest === undefined || databaseRequest === null) {
        throw new Error("Missing the required parameter 'databaseRequest' when calling putDatabases");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = DatabaseResponse;
      return this.apiClient.callApi(
        '/databases', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
