/**
 * devops
 * System Operations Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import Template from '../model/Template';
import TemplateRequest from '../model/TemplateRequest';
import TemplateResponse from '../model/TemplateResponse';

/**
* Template service.
* @module api/TemplateApi
* @version 0.0.2
*/
export default class TemplateApi {

    /**
    * Constructs a new TemplateApi. 
    * @alias module:api/TemplateApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getTemplate operation.
     * @callback module:api/TemplateApi~getTemplateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Template} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a single Template object
     * Return a single Template object from datastore as a Singleton
     * @param {String} templateIdPath Taxnexus Record Id of a Template
     * @param {module:api/TemplateApi~getTemplateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Template}
     */
    getTemplate(templateIdPath, callback) {
      let postBody = null;
      // verify the required parameter 'templateIdPath' is set
      if (templateIdPath === undefined || templateIdPath === null) {
        throw new Error("Missing the required parameter 'templateIdPath' when calling getTemplate");
      }

      let pathParams = {
        'templateIdPath': templateIdPath
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Template;
      return this.apiClient.callApi(
        '/templates/{templateIdPath}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getTemplates operation.
     * @callback module:api/TemplateApi~getTemplatesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TemplateResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list Templates
     * Return a list of Templates from the datastore
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip? (default 0)
     * @param {Boolean} opts.active Retrieve active records only?
     * @param {String} opts.templateId Template ID
     * @param {Boolean} opts.isMaster Is Master Template?
     * @param {String} opts.objectType Object Type Name
     * @param {module:api/TemplateApi~getTemplatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TemplateResponse}
     */
    getTemplates(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'active': opts['active'],
        'templateId': opts['templateId'],
        'isMaster': opts['isMaster'],
        'objectType': opts['objectType']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = TemplateResponse;
      return this.apiClient.callApi(
        '/templates', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getTemplatesObservable operation.
     * @callback module:api/TemplateApi~getTemplatesObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Template>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Templates in an observable array
     * Returns a Template retrieval in a observable array
     * @param {module:api/TemplateApi~getTemplatesObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Template>}
     */
    getTemplatesObservable(callback) {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Template];
      return this.apiClient.callApi(
        '/templates/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postTemplates operation.
     * @callback module:api/TemplateApi~postTemplatesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TemplateResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Templates
     * Create new Templates
     * @param {module:model/TemplateRequest} templateRequest An array of Template records
     * @param {module:api/TemplateApi~postTemplatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TemplateResponse}
     */
    postTemplates(templateRequest, callback) {
      let postBody = templateRequest;
      // verify the required parameter 'templateRequest' is set
      if (templateRequest === undefined || templateRequest === null) {
        throw new Error("Missing the required parameter 'templateRequest' when calling postTemplates");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = TemplateResponse;
      return this.apiClient.callApi(
        '/templates', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
