/**
 * devops
 * System Operations Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import Tenant from '../model/Tenant';
import TenantRequest from '../model/TenantRequest';
import TenantResponse from '../model/TenantResponse';

/**
* Tenant service.
* @module api/TenantApi
* @version 0.0.2
*/
export default class TenantApi {

    /**
    * Constructs a new TenantApi. 
    * @alias module:api/TenantApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getTenant operation.
     * @callback module:api/TenantApi~getTenantCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Tenant} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a single Tenant object
     * Return a single Tenant object from datastore as a Singleton
     * @param {String} tenantIdPath Taxnexus Record Id of a Tenant
     * @param {module:api/TenantApi~getTenantCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Tenant}
     */
    getTenant(tenantIdPath, callback) {
      let postBody = null;
      // verify the required parameter 'tenantIdPath' is set
      if (tenantIdPath === undefined || tenantIdPath === null) {
        throw new Error("Missing the required parameter 'tenantIdPath' when calling getTenant");
      }

      let pathParams = {
        'tenantIdPath': tenantIdPath
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Tenant;
      return this.apiClient.callApi(
        '/tenants/{tenantIdPath}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getTenants operation.
     * @callback module:api/TenantApi~getTenantsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TenantResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list Tenants
     * Return a list of Tenant records from the datastore
     * @param {Object} opts Optional parameters
     * @param {String} opts.taxnexusAccount Taxnexus Account of a Tenant
     * @param {String} opts.tenantId Taxnexus Record Id of a Tenant
     * @param {String} opts.companyId Taxnexus Record Id of a Company
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip? (default 0)
     * @param {module:api/TenantApi~getTenantsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TenantResponse}
     */
    getTenants(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'taxnexusAccount': opts['taxnexusAccount'],
        'tenantId': opts['tenantId'],
        'companyId': opts['companyId'],
        'limit': opts['limit'],
        'offset': opts['offset']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = TenantResponse;
      return this.apiClient.callApi(
        '/tenants', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getTenantsObservable operation.
     * @callback module:api/TenantApi~getTenantsObservableCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Tenant>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Tenants in an observable array
     * Returns a Tenant retrieval in a observable array
     * @param {module:api/TenantApi~getTenantsObservableCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Tenant>}
     */
    getTenantsObservable(callback) {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [Tenant];
      return this.apiClient.callApi(
        '/tenants/observable', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postTenants operation.
     * @callback module:api/TenantApi~postTenantsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TenantResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Tenants
     * Create Tenants in Taxnexus
     * @param {module:model/TenantRequest} tenantRequest An array of Tenant records
     * @param {module:api/TenantApi~postTenantsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TenantResponse}
     */
    postTenants(tenantRequest, callback) {
      let postBody = tenantRequest;
      // verify the required parameter 'tenantRequest' is set
      if (tenantRequest === undefined || tenantRequest === null) {
        throw new Error("Missing the required parameter 'tenantRequest' when calling postTenants");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = TenantResponse;
      return this.apiClient.callApi(
        '/tenants', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putTenants operation.
     * @callback module:api/TenantApi~putTenantsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TenantResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Tenants
     * Update Tenant in Taxnexus
     * @param {module:model/TenantRequest} tenantRequest An array of Tenant records
     * @param {module:api/TenantApi~putTenantsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TenantResponse}
     */
    putTenants(tenantRequest, callback) {
      let postBody = tenantRequest;
      // verify the required parameter 'tenantRequest' is set
      if (tenantRequest === undefined || tenantRequest === null) {
        throw new Error("Missing the required parameter 'tenantRequest' when calling putTenants");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = TenantResponse;
      return this.apiClient.callApi(
        '/tenants', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
