/**
 * research
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Observation from './Observation';

/**
 * The Factor model module.
 * @module model/Factor
 * @version 0.0.2
 */
class Factor {
    /**
     * Constructs a new <code>Factor</code>.
     * A Factor of analysis within a research topic
     * @alias module:model/Factor
     */
    constructor() { 
        
        Factor.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Factor</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Factor} obj Optional instance to populate.
     * @return {module:model/Factor} The populated <code>Factor</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Factor();

            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('Name')) {
                obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
            }
            if (data.hasOwnProperty('Description')) {
                obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
            }
            if (data.hasOwnProperty('SiteURL')) {
                obj['SiteURL'] = ApiClient.convertToType(data['SiteURL'], 'String');
            }
            if (data.hasOwnProperty('TopicID')) {
                obj['TopicID'] = ApiClient.convertToType(data['TopicID'], 'String');
            }
            if (data.hasOwnProperty('Observations')) {
                obj['Observations'] = ApiClient.convertToType(data['Observations'], [Observation]);
            }
        }
        return obj;
    }


}

/**
 * Taxnexus Record Id
 * @member {String} ID
 */
Factor.prototype['ID'] = undefined;

/**
 * Created By User ID
 * @member {String} CreatedByID
 */
Factor.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Factor.prototype['CreatedDate'] = undefined;

/**
 * Last Modified By User ID
 * @member {String} LastModifiedByID
 */
Factor.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modified Date
 * @member {String} LastModifiedDate
 */
Factor.prototype['LastModifiedDate'] = undefined;

/**
 * Factor Name
 * @member {String} Name
 */
Factor.prototype['Name'] = undefined;

/**
 * Topic Description
 * @member {String} Description
 */
Factor.prototype['Description'] = undefined;

/**
 * The URL of the corresponding page on the CMS
 * @member {String} SiteURL
 */
Factor.prototype['SiteURL'] = undefined;

/**
 * The ID of the Topic that owns this Factor
 * @member {String} TopicID
 */
Factor.prototype['TopicID'] = undefined;

/**
 * The list of Observations used to analyze this industry
 * @member {Array.<module:model/Observation>} Observations
 */
Factor.prototype['Observations'] = undefined;






export default Factor;

