/**
 * research
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Observation model module.
 * @module model/Observation
 * @version 0.0.2
 */
class Observation {
    /**
     * Constructs a new <code>Observation</code>.
     * A data point collected while analyzing a Factor
     * @alias module:model/Observation
     */
    constructor() { 
        
        Observation.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Observation</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Observation} obj Optional instance to populate.
     * @return {module:model/Observation} The populated <code>Observation</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Observation();

            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('FactorID')) {
                obj['FactorID'] = ApiClient.convertToType(data['FactorID'], 'String');
            }
            if (data.hasOwnProperty('SubjectType')) {
                obj['SubjectType'] = ApiClient.convertToType(data['SubjectType'], Object);
            }
            if (data.hasOwnProperty('AccountID')) {
                obj['AccountID'] = ApiClient.convertToType(data['AccountID'], 'String');
            }
            if (data.hasOwnProperty('companyProductID')) {
                obj['companyProductID'] = ApiClient.convertToType(data['companyProductID'], 'String');
            }
            if (data.hasOwnProperty('Description')) {
                obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
            }
            if (data.hasOwnProperty('Value')) {
                obj['Value'] = ApiClient.convertToType(data['Value'], 'String');
            }
        }
        return obj;
    }


}

/**
 * Taxnexus Record Id
 * @member {String} ID
 */
Observation.prototype['ID'] = undefined;

/**
 * Created By User ID
 * @member {String} CreatedByID
 */
Observation.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Observation.prototype['CreatedDate'] = undefined;

/**
 * Last Modified By User ID
 * @member {String} LastModifiedByID
 */
Observation.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modified Date
 * @member {String} LastModifiedDate
 */
Observation.prototype['LastModifiedDate'] = undefined;

/**
 * The ID of the Factor that owns this Observation
 * @member {String} FactorID
 */
Observation.prototype['FactorID'] = undefined;

/**
 * Is the subject a Company or a Product?
 * @member {Object} SubjectType
 */
Observation.prototype['SubjectType'] = undefined;

/**
 * The ID of the Company being analyzed
 * @member {String} AccountID
 */
Observation.prototype['AccountID'] = undefined;

/**
 * The ID of the Product being analyzed
 * @member {String} companyProductID
 */
Observation.prototype['companyProductID'] = undefined;

/**
 * Notes concerning data collection
 * @member {String} Description
 */
Observation.prototype['Description'] = undefined;

/**
 * The data point collected
 * @member {String} Value
 */
Observation.prototype['Value'] = undefined;






export default Observation;

