# sf_gate

SfGate - JavaScript client for sf_gate
Customer Information Microservice
This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.2
- Package version: 0.0.2
- Build package: org.openapitools.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/), please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install sf_gate --save
```

Finally, you need to build the module:

```shell
npm run build
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

To use the link you just defined in your project, switch to the directory you want to use your sf_gate from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

Finally, you need to build the module:

```shell
npm run build
```

#### git

If the library is hosted at a git repository, e.g.https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var SfGate = require('sf_gate');

var defaultClient = SfGate.ApiClient.instance;
// Configure API key authorization: ApiKeyAuth
var ApiKeyAuth = defaultClient.authentications['ApiKeyAuth'];
ApiKeyAuth.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiKeyAuth.apiKeyPrefix['X-API-Key'] = "Token"

var api = new SfGate.AccountsApi()
var opts = {
  'accountId': "accountId_example" // {String} Taxnexus Record Id of an Account
};
var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.deleteAccount(opts, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://sf-gate.vernonkeenan.com:8080/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SfGate.AccountsApi* | [**deleteAccount**](docs/AccountsApi.md#deleteAccount) | **DELETE** /accounts | Delete An Account
*SfGate.AccountsApi* | [**getAccounts**](docs/AccountsApi.md#getAccounts) | **GET** /accounts | Get a list of accounts
*SfGate.AccountsApi* | [**postAccounts**](docs/AccountsApi.md#postAccounts) | **POST** /accounts | Add a new account to Taxnexus
*SfGate.AccountsApi* | [**putAccount**](docs/AccountsApi.md#putAccount) | **PUT** /accounts | Update a single account
*SfGate.AssetsApi* | [**getAssets**](docs/AssetsApi.md#getAssets) | **GET** /assets | Get a list of assets
*SfGate.AssetsApi* | [**postAssets**](docs/AssetsApi.md#postAssets) | **POST** /assets | Add a new asset to Taxnexus
*SfGate.ClustersApi* | [**getClusters**](docs/ClustersApi.md#getClusters) | **GET** /clusters | Get a list Clusters
*SfGate.ClustersApi* | [**postClusters**](docs/ClustersApi.md#postClusters) | **POST** /clusters | Create new Clusters
*SfGate.ClustersApi* | [**putClusters**](docs/ClustersApi.md#putClusters) | **PUT** /clusters | Update Clusters
*SfGate.CompanyProductsApi* | [**getCompanyProducts**](docs/CompanyProductsApi.md#getCompanyProducts) | **GET** /companyproducts | Get a list of companyproducts
*SfGate.CompanyProductsApi* | [**postCompanyProducts**](docs/CompanyProductsApi.md#postCompanyProducts) | **POST** /companyproducts | Add a new companyproduct to Taxnexus
*SfGate.ContactsApi* | [**getContacts**](docs/ContactsApi.md#getContacts) | **GET** /contacts | Get a Contact record
*SfGate.ContactsApi* | [**postContacts**](docs/ContactsApi.md#postContacts) | **POST** /contacts | Add a new Contacts to Taxnexus
*SfGate.ContractsApi* | [**getContracts**](docs/ContractsApi.md#getContracts) | **GET** /contracts | Get a list of contracts
*SfGate.ContractsApi* | [**postContracts**](docs/ContractsApi.md#postContracts) | **POST** /contracts | Add a new contract to Taxnexus
*SfGate.DatabasesApi* | [**getDatabases**](docs/DatabasesApi.md#getDatabases) | **GET** /databases | Get a list Databases
*SfGate.DatabasesApi* | [**postDatabases**](docs/DatabasesApi.md#postDatabases) | **POST** /databases | Create new Databases
*SfGate.DatabasesApi* | [**putDatabases**](docs/DatabasesApi.md#putDatabases) | **PUT** /databases | Update Databases
*SfGate.IndustriesApi* | [**getIndustries**](docs/IndustriesApi.md#getIndustries) | **GET** /industries | Get a list of industries
*SfGate.IndustriesApi* | [**postIndustries**](docs/IndustriesApi.md#postIndustries) | **POST** /industries | Add a new industry to Taxnexus
*SfGate.IndustryProductsApi* | [**postIndustryproducts**](docs/IndustryProductsApi.md#postIndustryproducts) | **POST** /industryproducts | Add a new industryproduct to Taxnexus
*SfGate.IndustryproductsApi* | [**getIndustryProducts**](docs/IndustryproductsApi.md#getIndustryProducts) | **GET** /industryproducts | Get a list of industryproducts
*SfGate.RolesApi* | [**getRoles**](docs/RolesApi.md#getRoles) | **GET** /roles | Get a list of Roles
*SfGate.TemplatesApi* | [**getTemplates**](docs/TemplatesApi.md#getTemplates) | **GET** /templates | Get PDF Rendering Templates
*SfGate.TenantsApi* | [**getTenants**](docs/TenantsApi.md#getTenants) | **GET** /tenants | Get a list Tenants
*SfGate.TenantsApi* | [**putTenants**](docs/TenantsApi.md#putTenants) | **PUT** /tenants | Update Tenants
*SfGate.TenantsApi* | [**tenants**](docs/TenantsApi.md#tenants) | **POST** /tenants | Create new Tenants
*SfGate.UsersApi* | [**getUsers**](docs/UsersApi.md#getUsers) | **GET** /users | Get a list Users


## Documentation for Models

 - [SfGate.Account](docs/Account.md)
 - [SfGate.AccountRequest](docs/AccountRequest.md)
 - [SfGate.AccountResponse](docs/AccountResponse.md)
 - [SfGate.Address](docs/Address.md)
 - [SfGate.Asset](docs/Asset.md)
 - [SfGate.AssetRequest](docs/AssetRequest.md)
 - [SfGate.AssetResponse](docs/AssetResponse.md)
 - [SfGate.Cluster](docs/Cluster.md)
 - [SfGate.ClusterRequest](docs/ClusterRequest.md)
 - [SfGate.ClusterResponse](docs/ClusterResponse.md)
 - [SfGate.CompanyProduct](docs/CompanyProduct.md)
 - [SfGate.CompanyProductRequest](docs/CompanyProductRequest.md)
 - [SfGate.CompanyProductResponse](docs/CompanyProductResponse.md)
 - [SfGate.Contact](docs/Contact.md)
 - [SfGate.ContactRequest](docs/ContactRequest.md)
 - [SfGate.ContactResponse](docs/ContactResponse.md)
 - [SfGate.Contract](docs/Contract.md)
 - [SfGate.ContractRequest](docs/ContractRequest.md)
 - [SfGate.ContractResponse](docs/ContractResponse.md)
 - [SfGate.Database](docs/Database.md)
 - [SfGate.DatabaseRequest](docs/DatabaseRequest.md)
 - [SfGate.DatabaseResponse](docs/DatabaseResponse.md)
 - [SfGate.DeleteResponse](docs/DeleteResponse.md)
 - [SfGate.Error](docs/Error.md)
 - [SfGate.Industry](docs/Industry.md)
 - [SfGate.IndustryProduct](docs/IndustryProduct.md)
 - [SfGate.IndustryProductRequest](docs/IndustryProductRequest.md)
 - [SfGate.IndustryProductResponse](docs/IndustryProductResponse.md)
 - [SfGate.IndustryRequest](docs/IndustryRequest.md)
 - [SfGate.IndustryResponse](docs/IndustryResponse.md)
 - [SfGate.InvalidError](docs/InvalidError.md)
 - [SfGate.InvalidErrorAllOf](docs/InvalidErrorAllOf.md)
 - [SfGate.Message](docs/Message.md)
 - [SfGate.Pagination](docs/Pagination.md)
 - [SfGate.RequestMeta](docs/RequestMeta.md)
 - [SfGate.ResponseMeta](docs/ResponseMeta.md)
 - [SfGate.Role](docs/Role.md)
 - [SfGate.RoleRequest](docs/RoleRequest.md)
 - [SfGate.RoleResponse](docs/RoleResponse.md)
 - [SfGate.Template](docs/Template.md)
 - [SfGate.TemplateResponse](docs/TemplateResponse.md)
 - [SfGate.Tenant](docs/Tenant.md)
 - [SfGate.TenantRequest](docs/TenantRequest.md)
 - [SfGate.TenantResponse](docs/TenantResponse.md)
 - [SfGate.TenantUser](docs/TenantUser.md)
 - [SfGate.User](docs/User.md)
 - [SfGate.UserResponse](docs/UserResponse.md)
 - [SfGate.UserRole](docs/UserRole.md)


## Documentation for Authorization



### ApiKeyAuth


- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header

