# SfGate.IndustryProductsApi

All URIs are relative to *http://sf-gate.vernonkeenan.com:8080/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**postIndustryproducts**](IndustryProductsApi.md#postIndustryproducts) | **POST** /industryproducts | Add a new industryproduct to Taxnexus



## postIndustryproducts

> IndustryProductResponse postIndustryproducts(industryRequest)

Add a new industryproduct to Taxnexus

Industry record to be added

### Example

```javascript
import SfGate from 'sf_gate';
let defaultClient = SfGate.ApiClient.instance;
// Configure API key authorization: ApiKeyAuth
let ApiKeyAuth = defaultClient.authentications['ApiKeyAuth'];
ApiKeyAuth.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiKeyAuth.apiKeyPrefix = 'Token';

let apiInstance = new SfGate.IndustryProductsApi();
let industryRequest = new SfGate.IndustryProductRequest(); // IndustryProductRequest | An array of new Industry records
apiInstance.postIndustryproducts(industryRequest, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **industryRequest** | [**IndustryProductRequest**](IndustryProductRequest.md)| An array of new Industry records | 

### Return type

[**IndustryProductResponse**](IndustryProductResponse.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

