# SfGate.IndustryproductsApi

All URIs are relative to *http://sf-gate.vernonkeenan.com:8080/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getIndustryProducts**](IndustryproductsApi.md#getIndustryProducts) | **GET** /industryproducts | Get a list of industryproducts



## getIndustryProducts

> IndustryProductResponse getIndustryProducts(opts)

Get a list of industryproducts

Return a list of all available IndustryProducts

### Example

```javascript
import SfGate from 'sf_gate';
let defaultClient = SfGate.ApiClient.instance;
// Configure API key authorization: ApiKeyAuth
let ApiKeyAuth = defaultClient.authentications['ApiKeyAuth'];
ApiKeyAuth.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiKeyAuth.apiKeyPrefix = 'Token';

let apiInstance = new SfGate.IndustryproductsApi();
let opts = {
  'limit': 789, // Number | How many objects to return at one time
  'offset': 789, // Number | How many objects to skip?
  'active': true, // Boolean | Only retrieve active records?
  'industryProductId': "industryProductId_example" // String | Taxnexus IndustryProduct record ID
};
apiInstance.getIndustryProducts(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Number**| How many objects to return at one time | [optional] 
 **offset** | **Number**| How many objects to skip? | [optional] 
 **active** | **Boolean**| Only retrieve active records? | [optional] 
 **industryProductId** | **String**| Taxnexus IndustryProduct record ID | [optional] 

### Return type

[**IndustryProductResponse**](IndustryProductResponse.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

