/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import ClusterRequest from '../model/ClusterRequest';
import ClusterResponse from '../model/ClusterResponse';
import Error from '../model/Error';

/**
* Clusters service.
* @module api/ClustersApi
* @version 0.0.2
*/
export default class ClustersApi {

    /**
    * Constructs a new ClustersApi. 
    * @alias module:api/ClustersApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getClusters operation.
     * @callback module:api/ClustersApi~getClustersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClusterResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list Clusters
     * Return a list of Cluster records from the datastore
     * @param {Object} opts Optional parameters
     * @param {String} opts.clusterId Taxnexus Record Id of a Cluster
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {module:api/ClustersApi~getClustersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ClusterResponse}
     */
    getClusters(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'clusterId': opts['clusterId'],
        'limit': opts['limit'],
        'offset': opts['offset']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ClusterResponse;
      return this.apiClient.callApi(
        '/clusters', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postClusters operation.
     * @callback module:api/ClustersApi~postClustersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClusterResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Clusters
     * Create Clusters in Taxnexus
     * @param {module:model/ClusterRequest} clusterRequest An array of Cluster records
     * @param {module:api/ClustersApi~postClustersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ClusterResponse}
     */
    postClusters(clusterRequest, callback) {
      let postBody = clusterRequest;
      // verify the required parameter 'clusterRequest' is set
      if (clusterRequest === undefined || clusterRequest === null) {
        throw new Error("Missing the required parameter 'clusterRequest' when calling postClusters");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ClusterResponse;
      return this.apiClient.callApi(
        '/clusters', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the putClusters operation.
     * @callback module:api/ClustersApi~putClustersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClusterResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Clusters
     * Update Cluster in Taxnexus
     * @param {module:model/ClusterRequest} clusterRequest An array of Cluster records
     * @param {module:api/ClustersApi~putClustersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ClusterResponse}
     */
    putClusters(clusterRequest, callback) {
      let postBody = clusterRequest;
      // verify the required parameter 'clusterRequest' is set
      if (clusterRequest === undefined || clusterRequest === null) {
        throw new Error("Missing the required parameter 'clusterRequest' when calling putClusters");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ClusterResponse;
      return this.apiClient.callApi(
        '/clusters', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
