/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import CompanyProductRequest from '../model/CompanyProductRequest';
import CompanyProductResponse from '../model/CompanyProductResponse';
import Error from '../model/Error';

/**
* CompanyProducts service.
* @module api/CompanyProductsApi
* @version 0.0.2
*/
export default class CompanyProductsApi {

    /**
    * Constructs a new CompanyProductsApi. 
    * @alias module:api/CompanyProductsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getCompanyProducts operation.
     * @callback module:api/CompanyProductsApi~getCompanyProductsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyProductResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of companyproducts
     * Return a list of all available CompanyProducts
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.companyProductId Taxnexus CompanyProduct record ID
     * @param {module:api/CompanyProductsApi~getCompanyProductsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyProductResponse}
     */
    getCompanyProducts(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'active': opts['active'],
        'companyProductId': opts['companyProductId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyProductResponse;
      return this.apiClient.callApi(
        '/companyproducts', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postCompanyProducts operation.
     * @callback module:api/CompanyProductsApi~postCompanyProductsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyProductResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new companyproduct to Taxnexus
     * Industry record to be added
     * @param {module:model/CompanyProductRequest} contactRequest An array of new Contact records
     * @param {module:api/CompanyProductsApi~postCompanyProductsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyProductResponse}
     */
    postCompanyProducts(contactRequest, callback) {
      let postBody = contactRequest;
      // verify the required parameter 'contactRequest' is set
      if (contactRequest === undefined || contactRequest === null) {
        throw new Error("Missing the required parameter 'contactRequest' when calling postCompanyProducts");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = CompanyProductResponse;
      return this.apiClient.callApi(
        '/companyproducts', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
