/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import ContactRequest from '../model/ContactRequest';
import ContactResponse from '../model/ContactResponse';
import Error from '../model/Error';

/**
* Contacts service.
* @module api/ContactsApi
* @version 0.0.2
*/
export default class ContactsApi {

    /**
    * Constructs a new ContactsApi. 
    * @alias module:api/ContactsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getContacts operation.
     * @callback module:api/ContactsApi~getContactsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContactResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a Contact record
     * Retrieve Contact records from the datastore
     * @param {Object} opts Optional parameters
     * @param {String} opts.contactId Taxnexus Record Id of a Contact
     * @param {Number} opts.limit How many objects to return at one time
     * @param {String} opts.name The Name of this Object
     * @param {Number} opts.offset How many objects to skip?
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.accountId Taxnexus Record Id of an Account
     * @param {String} opts.email Email address used for identity lookup
     * @param {module:api/ContactsApi~getContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContactResponse}
     */
    getContacts(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'contactId': opts['contactId'],
        'limit': opts['limit'],
        'name': opts['name'],
        'offset': opts['offset'],
        'active': opts['active'],
        'accountId': opts['accountId'],
        'email': opts['email']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ContactResponse;
      return this.apiClient.callApi(
        '/contacts', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postContacts operation.
     * @callback module:api/ContactsApi~postContactsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContactResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new Contacts to Taxnexus
     * Contacts record to be added
     * @param {module:model/ContactRequest} contactRequest An array of new Contact records
     * @param {module:api/ContactsApi~postContactsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContactResponse}
     */
    postContacts(contactRequest, callback) {
      let postBody = contactRequest;
      // verify the required parameter 'contactRequest' is set
      if (contactRequest === undefined || contactRequest === null) {
        throw new Error("Missing the required parameter 'contactRequest' when calling postContacts");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = ContactResponse;
      return this.apiClient.callApi(
        '/contacts', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
