/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import IndustryRequest from '../model/IndustryRequest';
import IndustryResponse from '../model/IndustryResponse';

/**
* Industries service.
* @module api/IndustriesApi
* @version 0.0.2
*/
export default class IndustriesApi {

    /**
    * Constructs a new IndustriesApi. 
    * @alias module:api/IndustriesApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getIndustries operation.
     * @callback module:api/IndustriesApi~getIndustriesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/IndustryResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of industries
     * Return a list of all available Industries
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.industryId Taxnexus Industry record ID
     * @param {module:api/IndustriesApi~getIndustriesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/IndustryResponse}
     */
    getIndustries(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'active': opts['active'],
        'industryId': opts['industryId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = IndustryResponse;
      return this.apiClient.callApi(
        '/industries', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the postIndustries operation.
     * @callback module:api/IndustriesApi~postIndustriesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/IndustryResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new industry to Taxnexus
     * Industry record to be added
     * @param {module:model/IndustryRequest} industryRequest An array of new Industry records
     * @param {module:api/IndustriesApi~postIndustriesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/IndustryResponse}
     */
    postIndustries(industryRequest, callback) {
      let postBody = industryRequest;
      // verify the required parameter 'industryRequest' is set
      if (industryRequest === undefined || industryRequest === null) {
        throw new Error("Missing the required parameter 'industryRequest' when calling postIndustries");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = IndustryResponse;
      return this.apiClient.callApi(
        '/industries', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
