/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import IndustryProductRequest from '../model/IndustryProductRequest';
import IndustryProductResponse from '../model/IndustryProductResponse';

/**
* IndustryProducts service.
* @module api/IndustryProductsApi
* @version 0.0.2
*/
export default class IndustryProductsApi {

    /**
    * Constructs a new IndustryProductsApi. 
    * @alias module:api/IndustryProductsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the postIndustryproducts operation.
     * @callback module:api/IndustryProductsApi~postIndustryproductsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/IndustryProductResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new industryproduct to Taxnexus
     * Industry record to be added
     * @param {module:model/IndustryProductRequest} industryRequest An array of new Industry records
     * @param {module:api/IndustryProductsApi~postIndustryproductsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/IndustryProductResponse}
     */
    postIndustryproducts(industryRequest, callback) {
      let postBody = industryRequest;
      // verify the required parameter 'industryRequest' is set
      if (industryRequest === undefined || industryRequest === null) {
        throw new Error("Missing the required parameter 'industryRequest' when calling postIndustryproducts");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = IndustryProductResponse;
      return this.apiClient.callApi(
        '/industryproducts', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
