/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Error from '../model/Error';
import IndustryProductResponse from '../model/IndustryProductResponse';

/**
* Industryproducts service.
* @module api/IndustryproductsApi
* @version 0.0.2
*/
export default class IndustryproductsApi {

    /**
    * Constructs a new IndustryproductsApi. 
    * @alias module:api/IndustryproductsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the getIndustryProducts operation.
     * @callback module:api/IndustryproductsApi~getIndustryProductsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/IndustryProductResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of industryproducts
     * Return a list of all available IndustryProducts
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit How many objects to return at one time
     * @param {Number} opts.offset How many objects to skip?
     * @param {Boolean} opts.active Only retrieve active records?
     * @param {String} opts.industryProductId Taxnexus IndustryProduct record ID
     * @param {module:api/IndustryproductsApi~getIndustryProductsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/IndustryProductResponse}
     */
    getIndustryProducts(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'active': opts['active'],
        'industryProductId': opts['industryProductId']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = IndustryProductResponse;
      return this.apiClient.callApi(
        '/industryproducts', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
