/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Address from './Address';

/**
 * The Account model module.
 * @module model/Account
 * @version 0.0.2
 */
class Account {
    /**
     * Constructs a new <code>Account</code>.
     * @alias module:model/Account
     */
    constructor() { 
        
        Account.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Account</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Account} obj Optional instance to populate.
     * @return {module:model/Account} The populated <code>Account</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Account();

            if (data.hasOwnProperty('TenantID')) {
                obj['TenantID'] = ApiClient.convertToType(data['TenantID'], 'String');
            }
            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('AccountNumber')) {
                obj['AccountNumber'] = ApiClient.convertToType(data['AccountNumber'], 'String');
            }
            if (data.hasOwnProperty('AccountSource')) {
                obj['AccountSource'] = ApiClient.convertToType(data['AccountSource'], 'String');
            }
            if (data.hasOwnProperty('AnnualRevenue')) {
                obj['AnnualRevenue'] = ApiClient.convertToType(data['AnnualRevenue'], 'Number');
            }
            if (data.hasOwnProperty('BillingAddress')) {
                obj['BillingAddress'] = Address.constructFromObject(data['BillingAddress']);
            }
            if (data.hasOwnProperty('BillingContactID')) {
                obj['BillingContactID'] = ApiClient.convertToType(data['BillingContactID'], 'String');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('CloseDate')) {
                obj['CloseDate'] = ApiClient.convertToType(data['CloseDate'], 'String');
            }
            if (data.hasOwnProperty('CloudRevenueTotal')) {
                obj['CloudRevenueTotal'] = ApiClient.convertToType(data['CloudRevenueTotal'], 'Number');
            }
            if (data.hasOwnProperty('CloudType')) {
                obj['CloudType'] = ApiClient.convertToType(data['CloudType'], 'String');
            }
            if (data.hasOwnProperty('CloudYear')) {
                obj['CloudYear'] = ApiClient.convertToType(data['CloudYear'], 'String');
            }
            if (data.hasOwnProperty('CrunchbaseURL')) {
                obj['CrunchbaseURL'] = ApiClient.convertToType(data['CrunchbaseURL'], 'String');
            }
            if (data.hasOwnProperty('Description')) {
                obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
            }
            if (data.hasOwnProperty('EarningsCall')) {
                obj['EarningsCall'] = ApiClient.convertToType(data['EarningsCall'], 'String');
            }
            if (data.hasOwnProperty('Email')) {
                obj['Email'] = ApiClient.convertToType(data['Email'], 'String');
            }
            if (data.hasOwnProperty('EquityFunding')) {
                obj['EquityFunding'] = ApiClient.convertToType(data['EquityFunding'], 'Number');
            }
            if (data.hasOwnProperty('Fax')) {
                obj['Fax'] = ApiClient.convertToType(data['Fax'], 'String');
            }
            if (data.hasOwnProperty('FoundedDate')) {
                obj['FoundedDate'] = ApiClient.convertToType(data['FoundedDate'], 'String');
            }
            if (data.hasOwnProperty('Industry')) {
                obj['Industry'] = ApiClient.convertToType(data['Industry'], 'String');
            }
            if (data.hasOwnProperty('Facebook')) {
                obj['Facebook'] = ApiClient.convertToType(data['Facebook'], 'String');
            }
            if (data.hasOwnProperty('Industries')) {
                obj['Industries'] = ApiClient.convertToType(data['Industries'], 'String');
            }
            if (data.hasOwnProperty('IPODate')) {
                obj['IPODate'] = ApiClient.convertToType(data['IPODate'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('LinkedIn')) {
                obj['LinkedIn'] = ApiClient.convertToType(data['LinkedIn'], 'String');
            }
            if (data.hasOwnProperty('Location')) {
                obj['Location'] = ApiClient.convertToType(data['Location'], 'String');
            }
            if (data.hasOwnProperty('MarketCapitalization')) {
                obj['MarketCapitalization'] = ApiClient.convertToType(data['MarketCapitalization'], 'Number');
            }
            if (data.hasOwnProperty('Name')) {
                obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
            }
            if (data.hasOwnProperty('NumberOfEmployees')) {
                obj['NumberOfEmployees'] = ApiClient.convertToType(data['NumberOfEmployees'], 'Number');
            }
            if (data.hasOwnProperty('NumberInvestments')) {
                obj['NumberInvestments'] = ApiClient.convertToType(data['NumberInvestments'], 'Number');
            }
            if (data.hasOwnProperty('OwnerID')) {
                obj['OwnerID'] = ApiClient.convertToType(data['OwnerID'], 'String');
            }
            if (data.hasOwnProperty('Ownership')) {
                obj['Ownership'] = ApiClient.convertToType(data['Ownership'], 'String');
            }
            if (data.hasOwnProperty('ParentID')) {
                obj['ParentID'] = ApiClient.convertToType(data['ParentID'], 'String');
            }
            if (data.hasOwnProperty('Phone')) {
                obj['Phone'] = ApiClient.convertToType(data['Phone'], 'String');
            }
            if (data.hasOwnProperty('Publish')) {
                obj['Publish'] = ApiClient.convertToType(data['Publish'], 'Boolean');
            }
            if (data.hasOwnProperty('SalesforceFirst')) {
                obj['SalesforceFirst'] = ApiClient.convertToType(data['SalesforceFirst'], 'Boolean');
            }
            if (data.hasOwnProperty('ShippingAddress')) {
                obj['ShippingAddress'] = Address.constructFromObject(data['ShippingAddress']);
            }
            if (data.hasOwnProperty('ShippingContactID')) {
                obj['ShippingContactID'] = ApiClient.convertToType(data['ShippingContactID'], 'String');
            }
            if (data.hasOwnProperty('SIC')) {
                obj['SIC'] = ApiClient.convertToType(data['SIC'], 'String');
            }
            if (data.hasOwnProperty('SICDesc')) {
                obj['SICDesc'] = ApiClient.convertToType(data['SICDesc'], 'String');
            }
            if (data.hasOwnProperty('Site')) {
                obj['Site'] = ApiClient.convertToType(data['Site'], 'String');
            }
            if (data.hasOwnProperty('TagLine')) {
                obj['TagLine'] = ApiClient.convertToType(data['TagLine'], 'String');
            }
            if (data.hasOwnProperty('TickerSymbol')) {
                obj['TickerSymbol'] = ApiClient.convertToType(data['TickerSymbol'], 'String');
            }
            if (data.hasOwnProperty('Type')) {
                obj['Type'] = ApiClient.convertToType(data['Type'], 'String');
            }
            if (data.hasOwnProperty('Twitter')) {
                obj['Twitter'] = ApiClient.convertToType(data['Twitter'], 'String');
            }
            if (data.hasOwnProperty('Website')) {
                obj['Website'] = ApiClient.convertToType(data['Website'], 'String');
            }
            if (data.hasOwnProperty('YearStarted')) {
                obj['YearStarted'] = ApiClient.convertToType(data['YearStarted'], 'String');
            }
        }
        return obj;
    }


}

/**
 * tenant identifier
 * @member {String} TenantID
 */
Account.prototype['TenantID'] = undefined;

/**
 * Taxnexus Account Id
 * @member {String} ID
 */
Account.prototype['ID'] = undefined;

/**
 * Account Number
 * @member {String} AccountNumber
 */
Account.prototype['AccountNumber'] = undefined;

/**
 * The marketing orgin of this account
 * @member {String} AccountSource
 */
Account.prototype['AccountSource'] = undefined;

/**
 * Annual Revenue Estimate
 * @member {Number} AnnualRevenue
 */
Account.prototype['AnnualRevenue'] = undefined;

/**
 * @member {module:model/Address} BillingAddress
 */
Account.prototype['BillingAddress'] = undefined;

/**
 * Contact ID
 * @member {String} BillingContactID
 */
Account.prototype['BillingContactID'] = undefined;

/**
 * Created By User ID
 * @member {String} CreatedByID
 */
Account.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Account.prototype['CreatedDate'] = undefined;

/**
 * Date company closed
 * @member {String} CloseDate
 */
Account.prototype['CloseDate'] = undefined;

/**
 * @member {Number} CloudRevenueTotal
 */
Account.prototype['CloudRevenueTotal'] = undefined;

/**
 * @member {String} CloudType
 */
Account.prototype['CloudType'] = undefined;

/**
 * @member {String} CloudYear
 */
Account.prototype['CloudYear'] = undefined;

/**
 * @member {String} CrunchbaseURL
 */
Account.prototype['CrunchbaseURL'] = undefined;

/**
 * Description
 * @member {String} Description
 */
Account.prototype['Description'] = undefined;

/**
 * @member {String} EarningsCall
 */
Account.prototype['EarningsCall'] = undefined;

/**
 * Main Account Email
 * @member {String} Email
 */
Account.prototype['Email'] = undefined;

/**
 * @member {Number} EquityFunding
 */
Account.prototype['EquityFunding'] = undefined;

/**
 * Fax
 * @member {String} Fax
 */
Account.prototype['Fax'] = undefined;

/**
 * @member {String} FoundedDate
 */
Account.prototype['FoundedDate'] = undefined;

/**
 * Industry
 * @member {String} Industry
 */
Account.prototype['Industry'] = undefined;

/**
 * @member {String} Facebook
 */
Account.prototype['Facebook'] = undefined;

/**
 * @member {String} Industries
 */
Account.prototype['Industries'] = undefined;

/**
 * @member {String} IPODate
 */
Account.prototype['IPODate'] = undefined;

/**
 * Last Modified By User ID
 * @member {String} LastModifiedByID
 */
Account.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modified Date
 * @member {String} LastModifiedDate
 */
Account.prototype['LastModifiedDate'] = undefined;

/**
 * @member {String} LinkedIn
 */
Account.prototype['LinkedIn'] = undefined;

/**
 * @member {String} Location
 */
Account.prototype['Location'] = undefined;

/**
 * @member {Number} MarketCapitalization
 */
Account.prototype['MarketCapitalization'] = undefined;

/**
 * Account Name
 * @member {String} Name
 */
Account.prototype['Name'] = undefined;

/**
 * Employee Count Estimate
 * @member {Number} NumberOfEmployees
 */
Account.prototype['NumberOfEmployees'] = undefined;

/**
 * Number of Locations Estimate
 * @member {Number} NumberInvestments
 */
Account.prototype['NumberInvestments'] = undefined;

/**
 * Account Owner User ID
 * @member {String} OwnerID
 */
Account.prototype['OwnerID'] = undefined;

/**
 * Ownership
 * @member {String} Ownership
 */
Account.prototype['Ownership'] = undefined;

/**
 * Parent Account
 * @member {String} ParentID
 */
Account.prototype['ParentID'] = undefined;

/**
 * Phone
 * @member {String} Phone
 */
Account.prototype['Phone'] = undefined;

/**
 * @member {Boolean} Publish
 */
Account.prototype['Publish'] = undefined;

/**
 * @member {Boolean} SalesforceFirst
 */
Account.prototype['SalesforceFirst'] = undefined;

/**
 * @member {module:model/Address} ShippingAddress
 */
Account.prototype['ShippingAddress'] = undefined;

/**
 * @member {String} ShippingContactID
 */
Account.prototype['ShippingContactID'] = undefined;

/**
 * SIC Code
 * @member {String} SIC
 */
Account.prototype['SIC'] = undefined;

/**
 * SIC Description
 * @member {String} SICDesc
 */
Account.prototype['SICDesc'] = undefined;

/**
 * Account Site
 * @member {String} Site
 */
Account.prototype['Site'] = undefined;

/**
 * @member {String} TagLine
 */
Account.prototype['TagLine'] = undefined;

/**
 * @member {String} TickerSymbol
 */
Account.prototype['TickerSymbol'] = undefined;

/**
 * Type
 * @member {String} Type
 */
Account.prototype['Type'] = undefined;

/**
 * @member {String} Twitter
 */
Account.prototype['Twitter'] = undefined;

/**
 * Website
 * @member {String} Website
 */
Account.prototype['Website'] = undefined;

/**
 * Year Started
 * @member {String} YearStarted
 */
Account.prototype['YearStarted'] = undefined;






export default Account;

