/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Address from './Address';

/**
 * The Contract model module.
 * @module model/Contract
 * @version 0.0.2
 */
class Contract {
    /**
     * Constructs a new <code>Contract</code>.
     * @alias module:model/Contract
     */
    constructor() { 
        
        Contract.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Contract</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Contract} obj Optional instance to populate.
     * @return {module:model/Contract} The populated <code>Contract</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Contract();

            if (data.hasOwnProperty('AccountID')) {
                obj['AccountID'] = ApiClient.convertToType(data['AccountID'], 'String');
            }
            if (data.hasOwnProperty('ActivatedByID')) {
                obj['ActivatedByID'] = ApiClient.convertToType(data['ActivatedByID'], 'String');
            }
            if (data.hasOwnProperty('ActivatedDate')) {
                obj['ActivatedDate'] = ApiClient.convertToType(data['ActivatedDate'], 'String');
            }
            if (data.hasOwnProperty('BillingAddress')) {
                obj['BillingAddress'] = Address.constructFromObject(data['BillingAddress']);
            }
            if (data.hasOwnProperty('BillingContactID')) {
                obj['BillingContactID'] = ApiClient.convertToType(data['BillingContactID'], 'String');
            }
            if (data.hasOwnProperty('CompanySignedDate')) {
                obj['CompanySignedDate'] = ApiClient.convertToType(data['CompanySignedDate'], 'String');
            }
            if (data.hasOwnProperty('CompanySignedID')) {
                obj['CompanySignedID'] = ApiClient.convertToType(data['CompanySignedID'], 'String');
            }
            if (data.hasOwnProperty('ContractNumber')) {
                obj['ContractNumber'] = ApiClient.convertToType(data['ContractNumber'], 'String');
            }
            if (data.hasOwnProperty('ContractTerm')) {
                obj['ContractTerm'] = ApiClient.convertToType(data['ContractTerm'], 'Number');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('CustomerSignedDate')) {
                obj['CustomerSignedDate'] = ApiClient.convertToType(data['CustomerSignedDate'], 'String');
            }
            if (data.hasOwnProperty('CustomerSignedID')) {
                obj['CustomerSignedID'] = ApiClient.convertToType(data['CustomerSignedID'], 'String');
            }
            if (data.hasOwnProperty('CustomerSignedTitle')) {
                obj['CustomerSignedTitle'] = ApiClient.convertToType(data['CustomerSignedTitle'], 'String');
            }
            if (data.hasOwnProperty('DefaultEndUserID')) {
                obj['DefaultEndUserID'] = ApiClient.convertToType(data['DefaultEndUserID'], 'String');
            }
            if (data.hasOwnProperty('Description')) {
                obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
            }
            if (data.hasOwnProperty('EndDate')) {
                obj['EndDate'] = ApiClient.convertToType(data['EndDate'], 'String');
            }
            if (data.hasOwnProperty('HourlyRate')) {
                obj['HourlyRate'] = ApiClient.convertToType(data['HourlyRate'], 'Number');
            }
            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('Name')) {
                obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
            }
            if (data.hasOwnProperty('PaymentMethodID')) {
                obj['PaymentMethodID'] = ApiClient.convertToType(data['PaymentMethodID'], 'String');
            }
            if (data.hasOwnProperty('PaymentTerms')) {
                obj['PaymentTerms'] = ApiClient.convertToType(data['PaymentTerms'], 'String');
            }
            if (data.hasOwnProperty('Perpetual')) {
                obj['Perpetual'] = ApiClient.convertToType(data['Perpetual'], 'Boolean');
            }
            if (data.hasOwnProperty('ShippingAddress')) {
                obj['ShippingAddress'] = Address.constructFromObject(data['ShippingAddress']);
            }
            if (data.hasOwnProperty('ShippingContactID')) {
                obj['ShippingContactID'] = ApiClient.convertToType(data['ShippingContactID'], 'String');
            }
            if (data.hasOwnProperty('StartDate')) {
                obj['StartDate'] = ApiClient.convertToType(data['StartDate'], 'String');
            }
            if (data.hasOwnProperty('Status')) {
                obj['Status'] = ApiClient.convertToType(data['Status'], 'String');
            }
            if (data.hasOwnProperty('TenantID')) {
                obj['TenantID'] = ApiClient.convertToType(data['TenantID'], 'String');
            }
        }
        return obj;
    }


}

/**
 * Account
 * @member {String} AccountID
 */
Contract.prototype['AccountID'] = undefined;

/**
 * Activated By
 * @member {String} ActivatedByID
 */
Contract.prototype['ActivatedByID'] = undefined;

/**
 * Activated Date
 * @member {String} ActivatedDate
 */
Contract.prototype['ActivatedDate'] = undefined;

/**
 * @member {module:model/Address} BillingAddress
 */
Contract.prototype['BillingAddress'] = undefined;

/**
 * Billing Contact
 * @member {String} BillingContactID
 */
Contract.prototype['BillingContactID'] = undefined;

/**
 * Company Signed Date
 * @member {String} CompanySignedDate
 */
Contract.prototype['CompanySignedDate'] = undefined;

/**
 * Company Signed By
 * @member {String} CompanySignedID
 */
Contract.prototype['CompanySignedID'] = undefined;

/**
 * Contract Number
 * @member {String} ContractNumber
 */
Contract.prototype['ContractNumber'] = undefined;

/**
 * Contract Term (months)
 * @member {Number} ContractTerm
 */
Contract.prototype['ContractTerm'] = undefined;

/**
 * Created By User ID
 * @member {String} CreatedByID
 */
Contract.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Contract.prototype['CreatedDate'] = undefined;

/**
 * Customer Signed Date
 * @member {String} CustomerSignedDate
 */
Contract.prototype['CustomerSignedDate'] = undefined;

/**
 * Customer Signed By
 * @member {String} CustomerSignedID
 */
Contract.prototype['CustomerSignedID'] = undefined;

/**
 * Customer Signed Title
 * @member {String} CustomerSignedTitle
 */
Contract.prototype['CustomerSignedTitle'] = undefined;

/**
 * End User
 * @member {String} DefaultEndUserID
 */
Contract.prototype['DefaultEndUserID'] = undefined;

/**
 * Description
 * @member {String} Description
 */
Contract.prototype['Description'] = undefined;

/**
 * Contract End Date
 * @member {String} EndDate
 */
Contract.prototype['EndDate'] = undefined;

/**
 * Hourly Rate
 * @member {Number} HourlyRate
 */
Contract.prototype['HourlyRate'] = undefined;

/**
 * Telnexus Record Id
 * @member {String} ID
 */
Contract.prototype['ID'] = undefined;

/**
 * Last Modified By User ID
 * @member {String} LastModifiedByID
 */
Contract.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modified Date
 * @member {String} LastModifiedDate
 */
Contract.prototype['LastModifiedDate'] = undefined;

/**
 * Contract Name
 * @member {String} Name
 */
Contract.prototype['Name'] = undefined;

/**
 * Payment Method
 * @member {String} PaymentMethodID
 */
Contract.prototype['PaymentMethodID'] = undefined;

/**
 * Payment Terms
 * @member {String} PaymentTerms
 */
Contract.prototype['PaymentTerms'] = undefined;

/**
 * Perpetual Agreement?
 * @member {Boolean} Perpetual
 */
Contract.prototype['Perpetual'] = undefined;

/**
 * @member {module:model/Address} ShippingAddress
 */
Contract.prototype['ShippingAddress'] = undefined;

/**
 * Shipping Contact
 * @member {String} ShippingContactID
 */
Contract.prototype['ShippingContactID'] = undefined;

/**
 * Contract Start Date
 * @member {String} StartDate
 */
Contract.prototype['StartDate'] = undefined;

/**
 * Status
 * @member {String} Status
 */
Contract.prototype['Status'] = undefined;

/**
 * Tenant Identifier
 * @member {String} TenantID
 */
Contract.prototype['TenantID'] = undefined;






export default Contract;

