/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Database model module.
 * @module model/Database
 * @version 0.0.2
 */
class Database {
    /**
     * Constructs a new <code>Database</code>.
     * A Database provisioned and owned by a Tenant
     * @alias module:model/Database
     */
    constructor() { 
        
        Database.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Database</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Database} obj Optional instance to populate.
     * @return {module:model/Database} The populated <code>Database</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Database();

            if (data.hasOwnProperty('active')) {
                obj['active'] = ApiClient.convertToType(data['active'], 'Boolean');
            }
            if (data.hasOwnProperty('clusterid')) {
                obj['clusterid'] = ApiClient.convertToType(data['clusterid'], 'String');
            }
            if (data.hasOwnProperty('createdbyid')) {
                obj['createdbyid'] = ApiClient.convertToType(data['createdbyid'], 'String');
            }
            if (data.hasOwnProperty('createddate')) {
                obj['createddate'] = ApiClient.convertToType(data['createddate'], 'String');
            }
            if (data.hasOwnProperty('databasename')) {
                obj['databasename'] = ApiClient.convertToType(data['databasename'], 'String');
            }
            if (data.hasOwnProperty('dsn')) {
                obj['dsn'] = ApiClient.convertToType(data['dsn'], 'String');
            }
            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('lastmodifiedbyid')) {
                obj['lastmodifiedbyid'] = ApiClient.convertToType(data['lastmodifiedbyid'], 'String');
            }
            if (data.hasOwnProperty('lastmodifieddate')) {
                obj['lastmodifieddate'] = ApiClient.convertToType(data['lastmodifieddate'], 'String');
            }
            if (data.hasOwnProperty('microservices')) {
                obj['microservices'] = ApiClient.convertToType(data['microservices'], 'String');
            }
            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'String');
            }
            if (data.hasOwnProperty('tenantid')) {
                obj['tenantid'] = ApiClient.convertToType(data['tenantid'], 'String');
            }
            if (data.hasOwnProperty('type')) {
                obj['type'] = ApiClient.convertToType(data['type'], 'String');
            }
        }
        return obj;
    }


}

/**
 * Is this database active?
 * @member {Boolean} active
 */
Database.prototype['active'] = undefined;

/**
 * The ID of the Cluster in which this database is deployed
 * @member {String} clusterid
 */
Database.prototype['clusterid'] = undefined;

/**
 * Created By
 * @member {String} createdbyid
 */
Database.prototype['createdbyid'] = undefined;

/**
 * Created Date
 * @member {String} createddate
 */
Database.prototype['createddate'] = undefined;

/**
 * The name of the physical database in the cluster
 * @member {String} databasename
 */
Database.prototype['databasename'] = undefined;

/**
 * Database connection string
 * @member {String} dsn
 */
Database.prototype['dsn'] = undefined;

/**
 * Record Id
 * @member {String} id
 */
Database.prototype['id'] = undefined;

/**
 * Last Modified By
 * @member {String} lastmodifiedbyid
 */
Database.prototype['lastmodifiedbyid'] = undefined;

/**
 * Last Modifed Date
 * @member {String} lastmodifieddate
 */
Database.prototype['lastmodifieddate'] = undefined;

/**
 * List of Taxnexus microservices implemented by this Database
 * @member {String} microservices
 */
Database.prototype['microservices'] = undefined;

/**
 * The current status of this Tenant
 * @member {String} status
 */
Database.prototype['status'] = undefined;

/**
 * The ID of the tenant who owns this Database
 * @member {String} tenantid
 */
Database.prototype['tenantid'] = undefined;

/**
 * The type of Database (mysql, etc)
 * @member {String} type
 */
Database.prototype['type'] = undefined;






export default Database;

