/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Industry model module.
 * @module model/Industry
 * @version 0.0.2
 */
class Industry {
    /**
     * Constructs a new <code>Industry</code>.
     * An industry that is being researched
     * @alias module:model/Industry
     */
    constructor() { 
        
        Industry.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Industry</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Industry} obj Optional instance to populate.
     * @return {module:model/Industry} The populated <code>Industry</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Industry();

            if (data.hasOwnProperty('ID')) {
                obj['ID'] = ApiClient.convertToType(data['ID'], 'String');
            }
            if (data.hasOwnProperty('CreatedByID')) {
                obj['CreatedByID'] = ApiClient.convertToType(data['CreatedByID'], 'String');
            }
            if (data.hasOwnProperty('CreatedDate')) {
                obj['CreatedDate'] = ApiClient.convertToType(data['CreatedDate'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedByID')) {
                obj['LastModifiedByID'] = ApiClient.convertToType(data['LastModifiedByID'], 'String');
            }
            if (data.hasOwnProperty('LastModifiedDate')) {
                obj['LastModifiedDate'] = ApiClient.convertToType(data['LastModifiedDate'], 'String');
            }
            if (data.hasOwnProperty('Name')) {
                obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
            }
            if (data.hasOwnProperty('Description')) {
                obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
            }
            if (data.hasOwnProperty('ParentIndustryID')) {
                obj['ParentIndustryID'] = ApiClient.convertToType(data['ParentIndustryID'], 'String');
            }
            if (data.hasOwnProperty('Level')) {
                obj['Level'] = ApiClient.convertToType(data['Level'], 'String');
            }
            if (data.hasOwnProperty('Path')) {
                obj['Path'] = ApiClient.convertToType(data['Path'], 'String');
            }
            if (data.hasOwnProperty('Slug')) {
                obj['Slug'] = ApiClient.convertToType(data['Slug'], 'String');
            }
            if (data.hasOwnProperty('SiteURL')) {
                obj['SiteURL'] = ApiClient.convertToType(data['SiteURL'], 'String');
            }
        }
        return obj;
    }


}

/**
 * Taxnexus Record Id
 * @member {String} ID
 */
Industry.prototype['ID'] = undefined;

/**
 * Created By User ID
 * @member {String} CreatedByID
 */
Industry.prototype['CreatedByID'] = undefined;

/**
 * Created Date
 * @member {String} CreatedDate
 */
Industry.prototype['CreatedDate'] = undefined;

/**
 * Last Modified By User ID
 * @member {String} LastModifiedByID
 */
Industry.prototype['LastModifiedByID'] = undefined;

/**
 * Last Modified Date
 * @member {String} LastModifiedDate
 */
Industry.prototype['LastModifiedDate'] = undefined;

/**
 * Industry Name
 * @member {String} Name
 */
Industry.prototype['Name'] = undefined;

/**
 * Industry Description
 * @member {String} Description
 */
Industry.prototype['Description'] = undefined;

/**
 * The ID of the Parent Industry
 * @member {String} ParentIndustryID
 */
Industry.prototype['ParentIndustryID'] = undefined;

/**
 * The hierarchical level of this Industry
 * @member {String} Level
 */
Industry.prototype['Level'] = undefined;

/**
 * The full path of this industry, including Parent
 * @member {String} Path
 */
Industry.prototype['Path'] = undefined;

/**
 * The CMS Slug for this Industry
 * @member {String} Slug
 */
Industry.prototype['Slug'] = undefined;

/**
 * The URL of the corresponding page on the CMS
 * @member {String} SiteURL
 */
Industry.prototype['SiteURL'] = undefined;






export default Industry;

