/**
 * sf-gate
 * Customer Information Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Database from './Database';
import Role from './Role';
import TenantUser from './TenantUser';

/**
 * The Tenant model module.
 * @module model/Tenant
 * @version 0.0.2
 */
class Tenant {
    /**
     * Constructs a new <code>Tenant</code>.
     * Taxnexus Account Tenant
     * @alias module:model/Tenant
     */
    constructor() { 
        
        Tenant.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Tenant</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Tenant} obj Optional instance to populate.
     * @return {module:model/Tenant} The populated <code>Tenant</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Tenant();

            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('accountid')) {
                obj['accountid'] = ApiClient.convertToType(data['accountid'], 'String');
            }
            if (data.hasOwnProperty('active')) {
                obj['active'] = ApiClient.convertToType(data['active'], 'Boolean');
            }
            if (data.hasOwnProperty('createdbyid')) {
                obj['createdbyid'] = ApiClient.convertToType(data['createdbyid'], 'String');
            }
            if (data.hasOwnProperty('createddate')) {
                obj['createddate'] = ApiClient.convertToType(data['createddate'], 'String');
            }
            if (data.hasOwnProperty('lastmodifiedbyid')) {
                obj['lastmodifiedbyid'] = ApiClient.convertToType(data['lastmodifiedbyid'], 'String');
            }
            if (data.hasOwnProperty('lastmodifieddate')) {
                obj['lastmodifieddate'] = ApiClient.convertToType(data['lastmodifieddate'], 'String');
            }
            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'String');
            }
            if (data.hasOwnProperty('tenantname')) {
                obj['tenantname'] = ApiClient.convertToType(data['tenantname'], 'String');
            }
            if (data.hasOwnProperty('type')) {
                obj['type'] = ApiClient.convertToType(data['type'], 'String');
            }
            if (data.hasOwnProperty('version')) {
                obj['version'] = ApiClient.convertToType(data['version'], 'String');
            }
            if (data.hasOwnProperty('databases')) {
                obj['databases'] = ApiClient.convertToType(data['databases'], [Database]);
            }
            if (data.hasOwnProperty('roles')) {
                obj['roles'] = ApiClient.convertToType(data['roles'], [Role]);
            }
            if (data.hasOwnProperty('tenantusers')) {
                obj['tenantusers'] = ApiClient.convertToType(data['tenantusers'], [TenantUser]);
            }
        }
        return obj;
    }


}

/**
 * Record Id
 * @member {String} id
 */
Tenant.prototype['id'] = undefined;

/**
 * The Account that owns this Tenant
 * @member {String} accountid
 */
Tenant.prototype['accountid'] = undefined;

/**
 * Is this Tenant currently active?
 * @member {Boolean} active
 */
Tenant.prototype['active'] = undefined;

/**
 * Created By
 * @member {String} createdbyid
 */
Tenant.prototype['createdbyid'] = undefined;

/**
 * Created Date
 * @member {String} createddate
 */
Tenant.prototype['createddate'] = undefined;

/**
 * Last Modified By
 * @member {String} lastmodifiedbyid
 */
Tenant.prototype['lastmodifiedbyid'] = undefined;

/**
 * Last Modifed Date
 * @member {String} lastmodifieddate
 */
Tenant.prototype['lastmodifieddate'] = undefined;

/**
 * The current status of this Tenant
 * @member {String} status
 */
Tenant.prototype['status'] = undefined;

/**
 * Name of the Tenant Resource
 * @member {String} tenantname
 */
Tenant.prototype['tenantname'] = undefined;

/**
 * Type of tenant
 * @member {String} type
 */
Tenant.prototype['type'] = undefined;

/**
 * The version number of the Tenant Onboarding system used to create this tenant
 * @member {String} version
 */
Tenant.prototype['version'] = undefined;

/**
 * @member {Array.<module:model/Database>} databases
 */
Tenant.prototype['databases'] = undefined;

/**
 * @member {Array.<module:model/Role>} roles
 */
Tenant.prototype['roles'] = undefined;

/**
 * @member {Array.<module:model/TenantUser>} tenantusers
 */
Tenant.prototype['tenantusers'] = undefined;






export default Tenant;

