/**
 * stash
 * PDF Storage Microservice
 *
 * The version of the OpenAPI document: 0.0.2
 * Contact: noc@taxnexus.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import DocumentResponse from '../model/DocumentResponse';
import Error from '../model/Error';
import PDFRequest from '../model/PDFRequest';

/**
* StashPdf service.
* @module api/StashPdfApi
* @version 0.0.2
*/
export default class StashPdfApi {

    /**
    * Constructs a new StashPdfApi. 
    * @alias module:api/StashPdfApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the postPdfs operation.
     * @callback module:api/StashPdfApi~postPdfsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DocumentResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new PDFs
     * Store new PDFs
     * @param {module:model/PDFRequest} pDFRequest An array of new PDF records
     * @param {module:api/StashPdfApi~postPdfsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DocumentResponse}
     */
    postPdfs(pDFRequest, callback) {
      let postBody = pDFRequest;
      // verify the required parameter 'pDFRequest' is set
      if (pDFRequest === undefined || pDFRequest === null) {
        throw new Error("Missing the required parameter 'pDFRequest' when calling postPdfs");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['ApiKeyAuth'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = DocumentResponse;
      return this.apiClient.callApi(
        '/pdfs', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
